c---------------------------------
      subroutine csa_read
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.IOUNITS'

      open(icsa_in,file=csa_in,status="old",err=100)
       read(icsa_in,*) nconf
       read(icsa_in,*) jstart,jend
       read(icsa_in,*) nstmax
       read(icsa_in,*) n1,n2,n3,n4,n5,n6,n7,n8,is1,is2
       read(icsa_in,*) nran0,nran1,irr
       read(icsa_in,*) nseed
       read(icsa_in,*) ntotal,cut1,cut2
       read(icsa_in,*) estop
       read(icsa_in,*) icmax,irestart
       read(icsa_in,*) ntbankm,dele,difcut
       read(icsa_in,*) iref,rmscut,pnccut
       read(icsa_in,*) ndiff
      close(icsa_in)

      return

 100  continue
      return
      end
c---------------------------------
      subroutine initial_write
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'
      include 'COMMON.IOUNITS'

      open(icsa_seed,file=csa_seed,status="unknown")
       write(icsa_seed,*) "seed"
      close(31)
#if defined(AIX) || defined(PGI)
       open(icsa_history,file=csa_history,status="unknown",
     &  position="append")
#else
       open(icsa_history,file=csa_history,status="unknown",
     &  access="append")
#endif
       write(icsa_history,*) nconf
       write(icsa_history,*) jstart,jend
       write(icsa_history,*) nstmax
       write(icsa_history,*) n1,n2,n3,n4,n5,n6,n7,n8,is1,is2
       write(icsa_history,*) nran0,nran1,irr
       write(icsa_history,*) nseed
       write(icsa_history,*) ntotal,cut1,cut2
       write(icsa_history,*) estop
       write(icsa_history,*) icmax,irestart
       write(icsa_history,*) ntbankm,dele,difcut
       write(icsa_history,*) iref,rmscut,pnccut
       write(icsa_history,*) ndiff

       write(icsa_history,*)
      close(icsa_history)

      open(icsa_bank1,file=csa_bank1,status="unknown")
       write(icsa_bank1,*) 0
      close(icsa_bank1)

      return
      end
c---------------------------------
      subroutine restart_write
      implicit real*8 (a-h,o-z)
      include 'DIMENSIONS'
      include 'COMMON.IOUNITS'
      include 'COMMON.CSA'
      include 'COMMON.BANK'

#if defined(AIX) || defined(PGI)
       open(icsa_history,file=csa_history,position="append")
#else
       open(icsa_history,file=csa_history,access="append")
#endif
       write(icsa_history,*)
       write(icsa_history,*) "This is restart"
       write(icsa_history,*)
       write(icsa_history,*) nconf
       write(icsa_history,*) jstart,jend
       write(icsa_history,*) nstmax
       write(icsa_history,*) n1,n2,n3,n4,n5,n6,n7,n8,is1,is2
       write(icsa_history,*) nran0,nran1,irr
       write(icsa_history,*) nseed
       write(icsa_history,*) ntotal,cut1,cut2
       write(icsa_history,*) estop
       write(icsa_history,*) icmax,irestart
       write(icsa_history,*) ntbankm,dele,difcut
       write(icsa_history,*) iref,rmscut,pnccut
       write(icsa_history,*) ndiff
       write(icsa_history,*)
       write(icsa_history,*) "irestart is: ", irestart

       write(icsa_history,*)
      close(icsa_history)

      return
      end
c---------------------------------
